<template>
    <div
        v-if="shop"
        class="email-preview-container"
    >
        <div class="email-preview-header">
            <span
                class="email-preview-header__subject"
                v-html="replaceText(data.subject)"
            />
            <span class="email-preview-header__shopname">admin@stilyoapps.com</span>
            <img
                src="../../../../assets/images/subject_fix_bg.jpg"
                class="email-preview-header__img"
            >
        </div>
        <div class="main-content">
            <div class="main-wrapper">
                <table width="100%">
                    <tbody>
                        <tr class="content-wrapper">
                            <td>
                                <table width="100%">
                                    <tbody>
                                        <tr class="email-header">
                                            <td
                                                v-if="data.logo && data.logo !== ''"
                                                :style="{background: '#fff'}"
                                                class="text-center"
                                                align="left"
                                                valign="middle"
                                            >
                                                <img
                                                    style="max-width: 100%"
                                                    :src="data.logo"
                                                >
                                            </td>
                                        </tr>
                                        <tr class="mail-title">
                                            <td align="center">
                                                <!-- <div
                                                    class="preview"
                                                    v-html="replaceText(data.pre_header)"
                                                /> -->
                                                <strong
                                                    :style="{color: data.colors.title}"
                                                    v-html="replaceText(data.title)"
                                                />
                                            </td>
                                        </tr>
                                        <tr class="mail-description">
                                            <td
                                                :style="{color: data.colors.body_text}"
                                                v-html="replaceText(data.paragraph_1)"
                                            />
                                        </tr>
                                        <tr
                                            :style="{background: data.colors.highlighted_background}"
                                            class="highlighted-message"
                                        >
                                            <td
                                                :style="{color: data.colors.highlighted_text}"
                                                v-html="replaceText(data.highlighted_text)"
                                            />
                                        </tr>
                                        <tr class="mail-description">
                                            <td
                                                :style="{color: data.colors.body_text}"
                                                v-html="replaceText(data.paragraph_2)"
                                            />
                                        </tr>
                                        <tr class="action-button">
                                            <td align="center">
                                                <button
                                                    :style="{background: data.colors.button_color, color: data.colors.button_text}"
                                                    class="complete-button"
                                                    v-html="replaceText(data.button_text)"
                                                />
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </td>
                        </tr>
                        <tr class="footer">
                            <td valign="middle">
                                <table>
                                    <tbody>
                                        <tr>
                                            <td>
                                                <p
                                                    style="white-space: pre-line;"
                                                    v-html="replaceText(data.footer)"
                                                >
                                                    <a
                                                        :style="{color: data.colors.link}"
                                                        href="#"
                                                    >Unsubscribe</a>
                                                </p>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</template>

<script>
import shop from '../../../mixins/shop.service'

export default {
    name: "CampaignsEmailExample",
    mixins: [shop],
    props: ['data'],
    data() {
        return {
            code: Math.random().toString(36).slice(2, 8).toUpperCase(),
            shop: null,
        }
    },
    created() {
        this.loadShop()
    },
    methods: {
        async loadShop() {
            this.shop = await this.getShop()
        },
        replaceText(text) {
            text = text.replace(/{domain}/g, `<a style="color: ${this.data.colors.link}" href="#">` + (this.shop.site_url ? this.shop.site_url: 'Shop URL') + '</a>');
            text = text.replace(/{firstName}/g, 'John');
            text = text.replace(/{lastName}/g, 'Doe');
            text = text.replace(/{siteName}/g, this.shop.custom_name || this.shop.site_name);
            text = text.replace(/{campaignLink}/g, `<a style="color: ${this.data.colors.link}"  href="#">`);
            text = text.replace(/{\/campaignLink}/g, '</a>');
            text = text.replace(/{unsubscribeLink}/g, `<a style="color: ${this.data.colors.link}" href="#">`);
            text = text.replace(/{\/unsubscribeLink}/g, '</a>');
            text = text.replace(/{discountValue}/g, this.data.automatic_discount_value);
            text = text.replace(/{discountCode}/g, this.data.automatic_discount_enabled == false ? this.data.code : this.code);
            text = text.replace(/{storeEmail}/g,  this.shop.custom_email || this.shop.email || 'Email');

            return text;
        }
    }
}
</script>

<style scoped lang="scss">

.preview {
    font-size: 14px;
    color: rgb(3, 24, 59);
    margin-bottom: 20px;
}

.mail-description {
    white-space: pre-line;
}
.footer > td table td p:first-child {
    margin-bottom: 0;
}

</style>
